;****************************************************************************             
;*** 500 us delay
;****************************************************************************
; USES: T0, T1
D500us  MOVLW   2                  ;.4 us (5 vid 10 Mhz)
        MOVWF   T0                 ;.4 us
D500us1 MOVLW   .81                ;.4 us * 5  (81 vid 10Mhz)
        MOVWF   T1                 ;.4 us * 5
D500us2 DECFSZ  T1,1               ;1.2 us * 81 * 5 = 
        GOTO    D500us2
        DECFSZ  T0,1               ;.8 us * 5
        GOTO    D500us1		   ;.4 us * 5
	NOP
	NOP
	NOP
	NOP
	NOP
	NOP
        RETURN                     ;.8 us


;****************************************************************************             
;*** 60 us delay
;****************************************************************************
; USES: T0
D60us   MOVLW   .30                ;.4 us  (48 vid 10Mhz)
        MOVWF   T0                 ;.4 us
D60us1  DECFSZ  T0,1               ;1.2 us * 48 = 57.6
        GOTO    D60us1		   ; 
	NOP			   ;.4 us
	NOP			   ;.4 us
        RETURN                     ;.8 us


;****************************************************************************
;*** "Normal" Delay  500ms
;****************************************************************************
; USES: (T0),(T1),T2,T3
; CALL: D500us
D500ms  MOVLW   .5
        MOVWF   T2
D500ms1 MOVLW   .99
        MOVWF   T3
D500ms2 DECFSZ  T3,1
        GOTO    D500ms3
        GOTO    D500ms4
        GOTO    D500ms3
D500ms3 CALL    D500us
        CALL    D500us
        GOTO    D500ms2
D500ms4 DECFSZ  T2,1
        GOTO    D500ms1
	RETURN

;****************************************************************************
;*** Delay  100ms
;****************************************************************************
; USES: (T0),(T1),T2,T3
; CALL: D500us
D100ms  MOVLW   .4
        MOVWF   T2
D100ms1 MOVLW   .24
        MOVWF   T3
D100ms2 DECFSZ  T3,1
        GOTO    D100ms3
        GOTO    D100ms4
        GOTO    D100ms3
D100ms3 CALL    D500us
        CALL    D500us
        GOTO    D100ms2
D100ms4 DECFSZ  T2,1
        GOTO    D100ms1
	RETURN


;****************************************************************************
;*** Delay  10ms
;****************************************************************************
; USES: (T0),(T1),T2
; CALL: D500us
D10ms	MOVLW   .20
        MOVWF   T2
D10ms1	CALL	D500us
	DECFSZ  T2,F
        GOTO    D10ms1
	RETURN
